/***************************************************************************
 *  Copyright (C) 1995-2011 OSS Nokalva, Inc.  All rights reserved.
 ***************************************************************************
 *  THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 *  AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 *  THIS FILE MAY NOT BE DISTRIBUTED.
 ***************************************************************************
 */

/*

This sample program demonstrates automatic decoding of PDU containing
open type fields

*/

#include <stdlib.h>
#include <stdio.h>
#include "ranap.h"

#define PDU_NUMBER RANAP_PDU_PDU
#define CTLTBL ranap

unsigned char encodedMsg[] = {
    0x00 ,0x00 ,0x40 ,0x35 ,0x00 ,0x00 ,0x02 ,0x00 ,
    0x36 ,0x40 ,0x1F ,0x00 ,0x00 ,0x01 ,0x00 ,0x35 ,
    0x00 ,0x13 ,0x00 ,0xFE ,0x00 ,0x48 ,0x00 ,0x00 ,
    0x01 ,0x1E ,0x00 ,0x00 ,0x08 ,0x91 ,0xA0 ,0x00 ,
    0x00 ,0x12 ,0x34 ,0x56 ,0x78 ,0x40 ,0x03 ,0x10 ,
    0x00 ,0x09 ,0x00 ,0x29 ,0x40 ,0x0B ,0x00 ,0x00 ,
    0x01 ,0x00 ,0x28 ,0x40 ,0x04 ,0x00 ,0x01 ,0x02 ,
    0x00 
};

int main(void)
{
    /* buffer containing encoded data */
    OssBuf	buf;

    /* pointer to decoded message */
    void	*decodedMsg = NULL;

    /* identifies PDU to decode */
    int  	pdunum = PDU_NUMBER;

    /* OSS global structure */
    OssGlobal 	world;

    ossinit(&world, CTLTBL);    /* initialize OSS environment */

    ossSetEncodingRules(&world, OSS_PER_ALIGNED);
    ossSetFlags(&world, AUTOMATIC_ENCDEC | DEBUGPDU);

    buf.length = sizeof(encodedMsg);
    buf.value = encodedMsg;

    ossPrint(&world, "The decoder trace messages ...\n");

    if (ossDecode(&world, &pdunum, &buf, &decodedMsg)) {
	printf(ossGetErrMsg(&world));
    } else {
	ossPrint(&world, "The RANAP message decoded:\n");
	ossPrintPDU(&world, pdunum, decodedMsg);
    }

    ossFreePDU(&world, pdunum, decodedMsg);

    ossterm(&world);              /* cleanup OSS environment */

    return 0;
}
