#***************************************************************************
# Copyright (C) 1995-2011 OSS Nokalva, Inc.  All rights reserved.
#***************************************************************************
# THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
# AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
# THIS FILE MAY NOT BE DISTRIBUTED.
#***************************************************************************

#OSS_ASN1_C_DIR = $(OSSINFO)/ossasn1/linux-glibc2.2/prerelease9.0
OSS_ASN1_C_DIR = /home/thorpe/shipments/ossasn1

OSS_INC = $(OSS_ASN1_C_DIR)/include
OSS_LIB = $(OSS_ASN1_C_DIR)/lib

# Which archive ...
A = a

CC = gcc
 
LFLAGS = -lm
INCLUDES = -I. -I$(OSS_INC)
CFLAGS = $(INCLUDES) -g -DOSSPRINT -W -Wall
MORE = more <

#--------------------------------
EXECUTABLE1 = ./autodec
HANDWR1 = $(EXECUTABLE1)
EXECUTABLE2 = ./manualdec
HANDWR2 = $(EXECUTABLE2)
GENERATED = ranap
LIB = libasn1code
ASN1FILES = ranap-42kb.asn 
ASN1FLAGS = -per -root -soed ranap.c -headerFile ranap.h -extern ranap
ASN1 = $(OSS_ASN1_C_DIR)/bin/asn1
#--------------------------------

HFILES = $(OSS_INC)/asn1code.h $(OSS_INC)/asn1hdr.h $(OSS_INC)/ossber.h \
	$(OSS_INC)/asn1util.h $(OSS_INC)/etype.h $(OSS_INC)/ossglobl.h

.SUFFIXES: .o .c
.c.o:
	$(CC) $(CFLAGS) -c $<

all: $(EXECUTABLE1).txt $(EXECUTABLE2).txt
	$(MORE) $?

$(EXECUTABLE1).txt: $(EXECUTABLE1)
	$(EXECUTABLE1) > $(EXECUTABLE1).txt

$(EXECUTABLE2).txt: $(EXECUTABLE2)
	$(EXECUTABLE2) > $(EXECUTABLE2).txt

# Link the C-compiled output of the ASN.1 compiler with a demonstration
# application program and the runtime library.

$(EXECUTABLE1): $(HANDWR1).o $(GENERATED).o $(OSS_LIB)/$(LIB).$A autodec.mak
	$(CC) -o $@ $(HANDWR1).o $(GENERATED).o $(OSS_LIB)/$(LIB).$A $(LFLAGS)
	./$@

$(EXECUTABLE2): $(HANDWR2).o $(GENERATED).o $(OSS_LIB)/$(LIB).$A autodec.mak
	$(CC) -o $@ $(HANDWR2).o $(GENERATED).o $(OSS_LIB)/$(LIB).$A $(LFLAGS)
	./$@

$(HANDWR1).o $(HANDWR2).o: $(GENERATED).h $(HFILES) autodec.mak

# C-compile the output of the ASN.1 compiler

$(GENERATED).o: $(GENERATED).c $(GENERATED).h $(HFILES) autodec.mak

# ASN.1-compile the input ASN.1 file

$(GENERATED).c $(GENERATED).h: $(ASN1FILES) autodec.mak
	$(ASN1) $(ASN1FILES) $(ASN1FLAGS)

# Clean up

clean:
	rm -f	$(GENERATED).c \
		$(GENERATED).h \
		$(GENERATED).o \
		$(HANDWR1).o \
		$(HANDWR2).o \
		$(EXECUTABLE1) \
		$(EXECUTABLE2) \
		$(EXECUTABLE1).txt \
		$(EXECUTABLE2).txt


